Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision )
@@ -2684,27 +1090,34 @@
                         return array_unique($expected);
                     }
                     $yyruleno = $yyact - self::YYNSTATE;
-                    $this->yyidx -= self::$yyRuleInfo[$yyruleno]['rhs'];
-                    $nextstate = $this->yy_find_reduce_action(
-                        $this->yystack[$this->yyidx]->stateno,
-                        self::$yyRuleInfo[$yyruleno]['lhs']);
+                    $this->yyidx -= self::$yyRuleInfo[ $yyruleno ][ 1 ];
+                    $nextstate = $this->yy_find_reduce_action($this->yystack[ $this->yyidx ]->stateno,
+                                                              self::$yyRuleInfo[ $yyruleno ][ 0 ]);
-                    if (isset(self::$yyExpectedTokens[$nextstate])) {
+                    if (isset(self::$yyExpectedTokens[ $nextstate ])) {
-                        $expected = array_merge($expected, self::$yyExpectedTokens[$nextstate]);
+                        $expected = array_merge($expected, self::$yyExpectedTokens[ $nextstate ]);
-                        if (in_array($token,
-                                     self::$yyExpectedTokens[$nextstate], true)) {
+                        if (isset($res4[ $nextstate ][ $token ])) {
+                            if ($res4[ $nextstate ][ $token ]) {
-                            $this->yyidx = $yyidx;
-                            $this->yystack = $stack;
+                                $this->yyidx = $yyidx;
+                                $this->yystack = $stack;
-
-                            return array_unique($expected);
-                        }
+                                return array_unique($expected);
+                            }
+                        } else {
+                            if ($res4[ $nextstate ][ $token ] =
+                                in_array($token, self::$yyExpectedTokens[ $nextstate ], true)
+                            ) {
+                                $this->yyidx = $yyidx;
+                                $this->yystack = $stack;
+                                return array_unique($expected);
-                    }
+                            }
+                        }
+                    }
                     if ($nextstate < self::YYNSTATE) {
                         // we need to shift a non-terminal
                         $this->yyidx ++;
                         $x = new TP_yyStackEntry;
                         $x->stateno = $nextstate;
-                        $x->major = self::$yyRuleInfo[$yyruleno]['lhs'];
+                        $x->major = self::$yyRuleInfo[ $yyruleno ][ 0 ];
-                        $this->yystack[$this->yyidx] = $x;
+                        $this->yystack[ $this->yyidx ] = $x;
                         continue 2;
                     } elseif ($nextstate == self::YYNSTATE + self::YYNRULE + 1) {
                         $this->yyidx = $yyidx;
@@ -2733,13 +1146,21 @@
 
     public function yy_is_expected_token($token)
     {
+        static $res = array();
+        static $res2 = array();
         if ($token === 0) {
             return true; // 0 is not part of this
         }
-        $state = $this->yystack[$this->yyidx]->stateno;
+        $state = $this->yystack[ $this->yyidx ]->stateno;
-        if (in_array($token, self::$yyExpectedTokens[$state], true)) {
+        if (isset($res[ $state ][ $token ])) {
+            if ($res[ $state ][ $token ]) {
-            return true;
-        }
+                return true;
+            }
+        } else {
+            if ($res[ $state ][ $token ] = in_array($token, self::$yyExpectedTokens[ $state ], true)) {
+                return true;
+            }
+        }
         $stack = $this->yystack;
         $yyidx = $this->yyidx;
         do {
@@ -2756,25 +1177,31 @@
                         return true;
                     }
                     $yyruleno = $yyact - self::YYNSTATE;
-                    $this->yyidx -= self::$yyRuleInfo[$yyruleno]['rhs'];
-                    $nextstate = $this->yy_find_reduce_action(
-                        $this->yystack[$this->yyidx]->stateno,
-                        self::$yyRuleInfo[$yyruleno]['lhs']);
-                    if (isset(self::$yyExpectedTokens[$nextstate]) &&
-                        in_array($token, self::$yyExpectedTokens[$nextstate], true)
+                    $this->yyidx -= self::$yyRuleInfo[ $yyruleno ][ 1 ];
+                    $nextstate = $this->yy_find_reduce_action($this->yystack[ $this->yyidx ]->stateno,
+                                                              self::$yyRuleInfo[ $yyruleno ][ 0 ]);
+                    if (isset($res2[ $nextstate ][ $token ])) {
+                        if ($res2[ $nextstate ][ $token ]) {
+                            $this->yyidx = $yyidx;
+                            $this->yystack = $stack;
+                            return true;
+                        }
+                    } else {
+                        if ($res2[ $nextstate ][ $token ] = (isset(self::$yyExpectedTokens[ $nextstate ]) &&
+                            in_array($token, self::$yyExpectedTokens[ $nextstate ], true))
-                    ) {
-                        $this->yyidx = $yyidx;
-                        $this->yystack = $stack;
+                        ) {
+                            $this->yyidx = $yyidx;
+                            $this->yystack = $stack;
-
-                        return true;
-                    }
+                            return true;
+                        }
+                    }
                     if ($nextstate < self::YYNSTATE) {
                         // we need to shift a non-terminal
                         $this->yyidx ++;
                         $x = new TP_yyStackEntry;
                         $x->stateno = $nextstate;
-                        $x->major = self::$yyRuleInfo[$yyruleno]['lhs'];
+                        $x->major = self::$yyRuleInfo[ $yyruleno ][ 0 ];
-                        $this->yystack[$this->yyidx] = $x;
+                        $this->yystack[ $this->yyidx ] = $x;
                         continue 2;
                     } elseif ($nextstate == self::YYNSTATE + self::YYNRULE + 1) {
                         $this->yyidx = $yyidx;
@@ -2807,39 +1234,37 @@
 
     public function yy_find_shift_action($iLookAhead)
     {
-        $stateno = $this->yystack[$this->yyidx]->stateno;
+        $stateno = $this->yystack[ $this->yyidx ]->stateno;
 
         /* if ($this->yyidx < 0) return self::YY_NO_ACTION;  */
-        if (!isset(self::$yy_shift_ofst[$stateno])) {
+        if (!isset(self::$yy_shift_ofst[ $stateno ])) {
             // no shift actions
-            return self::$yy_default[$stateno];
+            return self::$yy_default[ $stateno ];
         }
-        $i = self::$yy_shift_ofst[$stateno];
+        $i = self::$yy_shift_ofst[ $stateno ];
         if ($i === self::YY_SHIFT_USE_DFLT) {
-            return self::$yy_default[$stateno];
+            return self::$yy_default[ $stateno ];
         }
         if ($iLookAhead == self::YYNOCODE) {
             return self::YY_NO_ACTION;
         }
         $i += $iLookAhead;
-        if ($i < 0 || $i >= self::YY_SZ_ACTTAB ||
-            self::$yy_lookahead[$i] != $iLookAhead
+        if ($i < 0 || $i >= self::YY_SZ_ACTTAB || self::$yy_lookahead[ $i ] != $iLookAhead) {
+            if (count(self::$yyFallback) && $iLookAhead < count(self::$yyFallback) &&
+                ($iFallback = self::$yyFallback[ $iLookAhead ]) != 0
-        ) {
+            ) {
-            if (count(self::$yyFallback) && $iLookAhead < count(self::$yyFallback)
-                && ($iFallback = self::$yyFallback[$iLookAhead]) != 0
-            ) {
                 if ($this->yyTraceFILE) {
-                    fwrite($this->yyTraceFILE, $this->yyTracePrompt . "FALLBACK " .
-                        $this->yyTokenName[$iLookAhead] . " => " .
+                    fwrite($this->yyTraceFILE,
+                           $this->yyTracePrompt . "FALLBACK " . $this->yyTokenName[ $iLookAhead ] . " => " .
-                        $this->yyTokenName[$iFallback] . "\n");
+                           $this->yyTokenName[ $iFallback ] . "\n");
                 }
 
                 return $this->yy_find_shift_action($iFallback);
             }
 
-            return self::$yy_default[$stateno];
+            return self::$yy_default[ $stateno ];
         } else {
-            return self::$yy_action[$i];
+            return self::$yy_action[ $i ];
         }
     }
 
@@ -2847,23 +1272,21 @@
     {
         /* $stateno = $this->yystack[$this->yyidx]->stateno; */
 
-        if (!isset(self::$yy_reduce_ofst[$stateno])) {
+        if (!isset(self::$yy_reduce_ofst[ $stateno ])) {
-            return self::$yy_default[$stateno];
+            return self::$yy_default[ $stateno ];
         }
-        $i = self::$yy_reduce_ofst[$stateno];
+        $i = self::$yy_reduce_ofst[ $stateno ];
         if ($i == self::YY_REDUCE_USE_DFLT) {
-            return self::$yy_default[$stateno];
+            return self::$yy_default[ $stateno ];
         }
         if ($iLookAhead == self::YYNOCODE) {
             return self::YY_NO_ACTION;
         }
         $i += $iLookAhead;
-        if ($i < 0 || $i >= self::YY_SZ_ACTTAB ||
-            self::$yy_lookahead[$i] != $iLookAhead
-        ) {
+        if ($i < 0 || $i >= self::YY_SZ_ACTTAB || self::$yy_lookahead[ $i ] != $iLookAhead) {
-            return self::$yy_default[$stateno];
+            return self::$yy_default[ $stateno ];
         } else {
-            return self::$yy_action[$i];
+            return self::$yy_action[ $i ];
         }
     }
 
@@ -2878,11 +1301,10 @@
             while ($this->yyidx >= 0) {
                 $this->yy_pop_parser_stack();
             }
-            #line 82 "smarty_internal_templateparser.y"
+            #line 214 "../smarty/lexer/smarty_internal_templateparser.y"
 
             $this->internalError = true;
             $this->compiler->trigger_template_error("Stack overflow in template parser");
-            #line 1721 "smarty_internal_templateparser.php"
 
             return;
         }
